#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
void print_usage(char *s) {
  fprintf(stderr, "%s data_file\n", s);
}

double Sum(double *p, unsigned int n) 
{
  double r = p[0];
  int i;
  
  for(i=1; i<n; i++) r += p[i];
  return(r);
}

int main(int argc, char **argv) 
{
  unsigned int l; //taille vecteur somme
  double *x, Cact; //vecteur somme, son cond effectif
  int delta_act; // delta effectif
  double *x0;

  double r0=0.0;

  int r;
  
  if (argc<2) 
    print_usage("ex1");
  
    int file = open(argv[1], O_RDONLY);
    if (file == -1) {printf("erreur ouverture data_file\n"); exit(1);}

    r = read(file, &l, sizeof(unsigned int)); 
    if (r!=sizeof(unsigned int)) {printf("erreur lecture data_file\n"); exit(1);}

    r = read(file, &Cact, sizeof(double));  
    if (r!=sizeof(double)) {printf("erreur lecture data_file\n"); exit(1);}

    r = read(file, &delta_act, sizeof(int));  
    if (r!=sizeof(int)) {printf("erreur lecture data_file\n"); exit(1);}

    x = (double *) malloc(sizeof(double)*l);
    for (int i=0; i<l; i++)
      {
	r = read(file, &x[i], sizeof(double));
	if(r != sizeof(double))
	  {
	    printf("erreur lecture data_file, arg num=%i\n", i);
	    exit(1);
	  }
      }
    close(file);

    x0 = malloc(sizeof(double)*l);

    memcpy(x0, x, sizeof(double)*l);
    r0 = Sum(x0, l);

    printf("%i \t %e \t %i \t ", l, Cact, delta_act);
    printf("\n");
    printf("Sum            %.16e\n", r0);
    return 0;
}
